]> asedeno.scripts.mit.edu Git - git.git/blob - git-bisect.sh
61a295664744d73bb32d1e563bd8bd5a3bca1204
[git.git] / git-bisect.sh
1 #!/bin/sh
2
3 USAGE='[start|bad|good|next|reset|visualize|replay|log|run]'
4 LONG_USAGE='git bisect start [<bad> [<good>...]] [--] [<pathspec>...]
5         reset bisect state and start bisection.
6 git bisect bad [<rev>]
7         mark <rev> a known-bad revision.
8 git bisect good [<rev>...]
9         mark <rev>... known-good revisions.
10 git bisect next
11         find next bisection to test and check it out.
12 git bisect reset [<branch>]
13         finish bisection search and go back to branch.
14 git bisect visualize
15         show bisect status in gitk.
16 git bisect replay <logfile>
17         replay bisection log.
18 git bisect log
19         show bisect log.
20 git bisect skip [<rev>...]
21         mark <rev>... untestable revisions.
22 git bisect run <cmd>...
23         use <cmd>... to automatically bisect.'
24
25 . git-sh-setup
26 require_work_tree
27
28 sq() {
29         @@PERL@@ -e '
30                 for (@ARGV) {
31                         s/'\''/'\'\\\\\'\''/g;
32                         print " '\''$_'\''";
33                 }
34                 print "\n";
35         ' "$@"
36 }
37
38 bisect_autostart() {
39         test -d "$GIT_DIR/refs/bisect" || {
40                 echo >&2 'You need to start by "git bisect start"'
41                 if test -t 0
42                 then
43                         echo >&2 -n 'Do you want me to do it for you [Y/n]? '
44                         read yesno
45                         case "$yesno" in
46                         [Nn]*)
47                                 exit ;;
48                         esac
49                         bisect_start
50                 else
51                         exit 1
52                 fi
53         }
54 }
55
56 bisect_start() {
57         #
58         # Verify HEAD. If we were bisecting before this, reset to the
59         # top-of-line master first!
60         #
61         head=$(GIT_DIR="$GIT_DIR" git symbolic-ref HEAD) ||
62         die "Bad HEAD - I need a symbolic ref"
63         case "$head" in
64         refs/heads/bisect)
65                 if [ -s "$GIT_DIR/head-name" ]; then
66                     branch=`cat "$GIT_DIR/head-name"`
67                 else
68                     branch=master
69                 fi
70                 git checkout $branch || exit
71                 ;;
72         refs/heads/*)
73                 [ -s "$GIT_DIR/head-name" ] && die "won't bisect on seeked tree"
74                 echo "$head" | sed 's#^refs/heads/##' >"$GIT_DIR/head-name"
75                 ;;
76         *)
77                 die "Bad HEAD - strange symbolic ref"
78                 ;;
79         esac
80
81         #
82         # Get rid of any old bisect state
83         #
84         bisect_clean_state
85         mkdir "$GIT_DIR/refs/bisect"
86
87         #
88         # Check for one bad and then some good revisions.
89         #
90         has_double_dash=0
91         for arg; do
92             case "$arg" in --) has_double_dash=1; break ;; esac
93         done
94         orig_args=$(sq "$@")
95         bad_seen=0
96         while [ $# -gt 0 ]; do
97             arg="$1"
98             case "$arg" in
99             --)
100                 shift
101                 break
102                 ;;
103             *)
104                 rev=$(git rev-parse --verify "$arg^{commit}" 2>/dev/null) || {
105                     test $has_double_dash -eq 1 &&
106                         die "'$arg' does not appear to be a valid revision"
107                     break
108                 }
109                 case $bad_seen in
110                 0) state='bad' ; bad_seen=1 ;;
111                 *) state='good' ;;
112                 esac
113                 bisect_write "$state" "$rev" 'nolog'
114                 shift
115                 ;;
116             esac
117         done
118
119         sq "$@" >"$GIT_DIR/BISECT_NAMES"
120         echo "git-bisect start$orig_args" >>"$GIT_DIR/BISECT_LOG"
121         bisect_auto_next
122 }
123
124 bisect_write() {
125         state="$1"
126         rev="$2"
127         nolog="$3"
128         case "$state" in
129                 bad)            tag="$state" ;;
130                 good|skip)      tag="$state"-"$rev" ;;
131                 *)              die "Bad bisect_write argument: $state" ;;
132         esac
133         echo "$rev" >"$GIT_DIR/refs/bisect/$tag"
134         echo "# $state: "$(git show-branch $rev) >>"$GIT_DIR/BISECT_LOG"
135         test -z "$nolog" && echo "git-bisect $state $rev" >>"$GIT_DIR/BISECT_LOG"
136 }
137
138 bisect_bad() {
139         bisect_autostart
140         case "$#" in
141         0)
142                 rev=$(git rev-parse --verify HEAD) ;;
143         1)
144                 rev=$(git rev-parse --verify "$1^{commit}") ;;
145         *)
146                 usage ;;
147         esac || exit
148         bisect_write 'bad' "$rev"
149         bisect_auto_next
150 }
151
152 bisect_good() {
153         bisect_autostart
154         case "$#" in
155         0)    revs=$(git rev-parse --verify HEAD) || exit ;;
156         *)    revs=$(git rev-parse --revs-only --no-flags "$@") &&
157                 test '' != "$revs" || die "Bad rev input: $@" ;;
158         esac
159         for rev in $revs
160         do
161                 rev=$(git rev-parse --verify "$rev^{commit}") || exit
162                 bisect_write 'good' "$rev"
163         done
164         bisect_auto_next
165 }
166
167 bisect_skip() {
168         bisect_autostart
169         case "$#" in
170         0)    revs=$(git rev-parse --verify HEAD) || exit ;;
171         *)    revs=$(git rev-parse --revs-only --no-flags "$@") &&
172                 test '' != "$revs" || die "Bad rev input: $@" ;;
173         esac
174         for rev in $revs
175         do
176                 rev=$(git rev-parse --verify "$rev^{commit}") || exit
177                 bisect_write 'skip' "$rev"
178         done
179         bisect_auto_next
180 }
181
182 bisect_next_check() {
183         missing_good= missing_bad=
184         git show-ref -q --verify refs/bisect/bad || missing_bad=t
185         test -n "$(git for-each-ref "refs/bisect/good-*")" || missing_good=t
186
187         case "$missing_good,$missing_bad,$1" in
188         ,,*)
189                 : have both good and bad - ok
190                 ;;
191         *,)
192                 # do not have both but not asked to fail - just report.
193                 false
194                 ;;
195         t,,good)
196                 # have bad but not good.  we could bisect although
197                 # this is less optimum.
198                 echo >&2 'Warning: bisecting only with a bad commit.'
199                 if test -t 0
200                 then
201                         printf >&2 'Are you sure [Y/n]? '
202                         case "$(read yesno)" in [Nn]*) exit 1 ;; esac
203                 fi
204                 : bisect without good...
205                 ;;
206         *)
207                 THEN=''
208                 test -d "$GIT_DIR/refs/bisect" || {
209                         echo >&2 'You need to start by "git bisect start".'
210                         THEN='then '
211                 }
212                 echo >&2 'You '$THEN'need to give me at least one good' \
213                         'and one bad revisions.'
214                 echo >&2 '(You can use "git bisect bad" and' \
215                         '"git bisect good" for that.)'
216                 exit 1 ;;
217         esac
218 }
219
220 bisect_auto_next() {
221         bisect_next_check && bisect_next || :
222 }
223
224 filter_skipped() {
225         _eval="$1"
226         _skip="$2"
227
228         if [ -z "$_skip" ]; then
229                 eval $_eval
230                 return
231         fi
232
233         # Let's parse the output of:
234         # "git rev-list --bisect-vars --bisect-all ..."
235         eval $_eval | while read hash line
236         do
237                 case "$VARS,$FOUND,$TRIED,$hash" in
238                         # We display some vars.
239                         1,*,*,*) echo "$hash $line" ;;
240
241                         # Split line.
242                         ,*,*,---*) ;;
243
244                         # We had nothing to search.
245                         ,,,bisect_rev*)
246                                 echo "bisect_rev="
247                                 VARS=1
248                                 ;;
249
250                         # We did not find a good bisect rev.
251                         # This should happen only if the "bad"
252                         # commit is also a "skip" commit.
253                         ,,*,bisect_rev*)
254                                 echo "bisect_rev=$TRIED"
255                                 VARS=1
256                                 ;;
257
258                         # We are searching.
259                         ,,*,*)
260                                 TRIED="${TRIED:+$TRIED|}$hash"
261                                 case "$_skip" in
262                                 *$hash*) ;;
263                                 *)
264                                         echo "bisect_rev=$hash"
265                                         echo "bisect_tried=\"$TRIED\""
266                                         FOUND=1
267                                         ;;
268                                 esac
269                                 ;;
270
271                         # We have already found a rev to be tested.
272                         ,1,*,bisect_rev*) VARS=1 ;;
273                         ,1,*,*) ;;
274
275                         # ???
276                         *) die "filter_skipped error " \
277                             "VARS: '$VARS' " \
278                             "FOUND: '$FOUND' " \
279                             "TRIED: '$TRIED' " \
280                             "hash: '$hash' " \
281                             "line: '$line'"
282                         ;;
283                 esac
284         done
285 }
286
287 exit_if_skipped_commits () {
288         _tried=$1
289         if expr "$_tried" : ".*[|].*" > /dev/null ; then
290                 echo "There are only 'skip'ped commit left to test."
291                 echo "The first bad commit could be any of:"
292                 echo "$_tried" | sed -e 's/[|]/\n/g'
293                 echo "We cannot bisect more!"
294                 exit 2
295         fi
296 }
297
298 bisect_next() {
299         case "$#" in 0) ;; *) usage ;; esac
300         bisect_autostart
301         bisect_next_check good
302
303         skip=$(git for-each-ref --format='%(objectname)' \
304                 "refs/bisect/skip-*" | tr '[\012]' ' ') || exit
305
306         BISECT_OPT=''
307         test -n "$skip" && BISECT_OPT='--bisect-all'
308
309         bad=$(git rev-parse --verify refs/bisect/bad) &&
310         good=$(git for-each-ref --format='^%(objectname)' \
311                 "refs/bisect/good-*" | tr '[\012]' ' ') &&
312         eval="git rev-list --bisect-vars $BISECT_OPT $good $bad --" &&
313         eval="$eval $(cat "$GIT_DIR/BISECT_NAMES")" &&
314         eval=$(filter_skipped "$eval" "$skip") &&
315         eval "$eval" || exit
316
317         if [ -z "$bisect_rev" ]; then
318                 echo "$bad was both good and bad"
319                 exit 1
320         fi
321         if [ "$bisect_rev" = "$bad" ]; then
322                 exit_if_skipped_commits "$bisect_tried"
323                 echo "$bisect_rev is first bad commit"
324                 git diff-tree --pretty $bisect_rev
325                 exit 0
326         fi
327
328         # We should exit here only if the "bad"
329         # commit is also a "skip" commit (see above).
330         exit_if_skipped_commits "$bisect_rev"
331
332         echo "Bisecting: $bisect_nr revisions left to test after this"
333         echo "$bisect_rev" >"$GIT_DIR/refs/heads/new-bisect"
334         git checkout -q new-bisect || exit
335         mv "$GIT_DIR/refs/heads/new-bisect" "$GIT_DIR/refs/heads/bisect" &&
336         GIT_DIR="$GIT_DIR" git symbolic-ref HEAD refs/heads/bisect
337         git show-branch "$bisect_rev"
338 }
339
340 bisect_visualize() {
341         bisect_next_check fail
342         not=`cd "$GIT_DIR/refs" && echo bisect/good-*`
343         eval gitk bisect/bad --not $not -- $(cat "$GIT_DIR/BISECT_NAMES")
344 }
345
346 bisect_reset() {
347         case "$#" in
348         0) if [ -s "$GIT_DIR/head-name" ]; then
349                branch=`cat "$GIT_DIR/head-name"`
350            else
351                branch=master
352            fi ;;
353         1) git show-ref --verify --quiet -- "refs/heads/$1" ||
354                die "$1 does not seem to be a valid branch"
355            branch="$1" ;;
356         *)
357             usage ;;
358         esac
359         if git checkout "$branch"; then
360                 rm -f "$GIT_DIR/head-name"
361                 bisect_clean_state
362         fi
363 }
364
365 bisect_clean_state() {
366         rm -fr "$GIT_DIR/refs/bisect"
367         rm -f "$GIT_DIR/refs/heads/bisect"
368         rm -f "$GIT_DIR/BISECT_LOG"
369         rm -f "$GIT_DIR/BISECT_NAMES"
370         rm -f "$GIT_DIR/BISECT_RUN"
371 }
372
373 bisect_replay () {
374         test -r "$1" || die "cannot read $1 for replaying"
375         bisect_reset
376         while read bisect command rev
377         do
378                 test "$bisect" = "git-bisect" || continue
379                 case "$command" in
380                 start)
381                         cmd="bisect_start $rev"
382                         eval "$cmd" ;;
383                 good|bad|skip)
384                         bisect_write "$command" "$rev" ;;
385                 *)
386                         die "?? what are you talking about?" ;;
387                 esac
388         done <"$1"
389         bisect_auto_next
390 }
391
392 bisect_run () {
393     bisect_next_check fail
394
395     while true
396     do
397       echo "running $@"
398       "$@"
399       res=$?
400
401       # Check for really bad run error.
402       if [ $res -lt 0 -o $res -ge 128 ]; then
403           echo >&2 "bisect run failed:"
404           echo >&2 "exit code $res from '$@' is < 0 or >= 128"
405           exit $res
406       fi
407
408       # Use "bisect_good" or "bisect_bad"
409       # depending on run success or failure.
410       if [ $res -gt 0 ]; then
411           next_bisect='bisect_bad'
412       else
413           next_bisect='bisect_good'
414       fi
415
416       # We have to use a subshell because bisect_good or
417       # bisect_bad functions can exit.
418       ( $next_bisect > "$GIT_DIR/BISECT_RUN" )
419       res=$?
420
421       cat "$GIT_DIR/BISECT_RUN"
422
423       if [ $res -ne 0 ]; then
424           echo >&2 "bisect run failed:"
425           echo >&2 "$next_bisect exited with error code $res"
426           exit $res
427       fi
428
429       if grep "is first bad commit" "$GIT_DIR/BISECT_RUN" > /dev/null; then
430           echo "bisect run success"
431           exit 0;
432       fi
433
434     done
435 }
436
437
438 case "$#" in
439 0)
440     usage ;;
441 *)
442     cmd="$1"
443     shift
444     case "$cmd" in
445     start)
446         bisect_start "$@" ;;
447     bad)
448         bisect_bad "$@" ;;
449     good)
450         bisect_good "$@" ;;
451     skip)
452         bisect_skip "$@" ;;
453     next)
454         # Not sure we want "next" at the UI level anymore.
455         bisect_next "$@" ;;
456     visualize)
457         bisect_visualize "$@" ;;
458     reset)
459         bisect_reset "$@" ;;
460     replay)
461         bisect_replay "$@" ;;
462     log)
463         cat "$GIT_DIR/BISECT_LOG" ;;
464     run)
465         bisect_run "$@" ;;
466     *)
467         usage ;;
468     esac
469 esac